
/*******************************************************************************
 *客户信息 
 * @author lijinrui
 * 
 ******************************************************************************/
function checkGps() {
	try {
		var opened = Util.getGpsState();
		if (true != opened) {
			alert("发现您没有打开系统GPS，请点击确定，并在系统设置中打开GPS(勾中\"使用GPS卫星\")。", function () {
				Util.startGpsSetting();
			});
		}
	}
	catch (e) {
	}
}
/**
 *重新定位
 */
function restartPos() {
	startPos("postionCallBack", true);
	document.getElementById("gps_status").innerHTML = "定位中<img src='res:image/dingwei.gif' />";
}
function startGpsIfFailed() {
}
/**
 * 定位响应
 */
function postionCallBack(msgType, data) {
	if (msgType == _MSG_POS_GPS || msgType == _MSG_POS_CELL) {
		$("customer.location").value = data.pos;
		$("gps_status").innerHTML = "正在获取位置信息<img src='res:image/dingwei.gif' />";
	} else {
		if (msgType == _MSG_GPS_CITY || msgType == _MSG_CELL_CITY) {
			$("gps_status").innerHTML = data.addr;
			$("customer.locationDesc").value = data.addr;
		} else {
			if (msgType == _MSG_ERROR_CITY) {
				$("gps_status").innerHTML = "未知[" + data.pos + "]";
				$("customer.locationDesc").value = data.addr;
			} else {
				if (msgType == _MSG_FAIL_CELL) {
					if ($("customer.location").value.isEmpty()) {
						$("gps_status").innerHTML = "<a style='text-decoration:underline;' href='javascript:restartPos();'>点击这里重新开始定位。</a>";
					}
				}
			}
		}
	}
}
/**
 * 基本信息收缩
 */
function openInfo() {
	var baseDiv = document.getElementById("baseInfo");
	var img = document.getElementById("openImg");
	if (baseDiv.style.display == "none") {
		baseDiv.style.display = "block";
		img.src = "res:image/treeClose.png";
	} else {
		baseDiv.style.display = "none";
		img.src = "res:image/treeOpen.png";
	}
}

	function choseTander(n){
				var url="http://ICUBE_URL/tss/trade/list.action?";
				if(n==1){
					url+="idField=tradeOptionId&idFieldAttr=value&nameField=tradeId&nameFieldAttr=value&callback=openTradeSelect";
					url+="&refList.optionCode=0004";
					$("tradeSubId").value="";
					$("tradeSubsectionId").value="";
					$("subListId").value="";
					$("subListCode").value="";
				}else if(n==2){
					url+="idField=tradeSubId&idFieldAttr=value&nameField=tradeSubsectionId&nameFieldAttr=value&callback=openTradeSelect";
					url+="&refList.dictionaryId="+$("tradeOptionId").value;
					$("subListId").value="";
					$("subListCode").value="";
					if($("tradeOptionId").value.isEmpty()){
						alert("请先选择一级行业!");return;
					}
				}else if(n==3){
					url+="idField=subListId&idFieldAttr=value&nameField=subListCode&nameFieldAttr=value&callback=openTradeSelect";
					url+="&refList.dictionaryId="+$("tradeSubId").value;
					if($("tradeOptionId").value.isEmpty()){
						alert("请先选择一级行业!");return;
					}
					if($("tradeSubId").value.isEmpty()){
						alert("请先选择二级行业!");return;
					}
				}
				window.open(url,true,false);
			}
/**
 *提交确认
 */
function submitConfirm() {
	if (check()) {
		confirm("\u662f\u5426\u786e\u8ba4\u63d0\u4ea4\u4fe1\u606f\uff1f", doSubmit, cancelCallBack);
	}
}

function successBack(response){
    if(response.status==200){
		var res=response.responseText.toJSON();
		if(res.flag){
			alert(res.msg,function(){
				 if(res.localId.isNotEmpty()){
					 customerDao.delLocalById(res.localId);
				 }
				 close();
			});
		}else{
			alert(res.msg);
		}
    }
 }
function failBack(response){
     var text = response.objName+"失败，状态为："+response.status;
     Log.i("specialUp",text);
}
/**
 *表单校验
 */
function check() {
	var reg = new Regex();
	var st = getValueByName("customer.customerState");
	if (st == "1") {
		//客户名称
		var customerName = getValueByName("customer.customerName");
		if (customerName.isEmpty()) {
			alert("\u5ba2\u6237\u540d\u79f0\u4e0d\u53ef\u4e3a\u7a7a!");
			return;
		}
		if (getSelectedTextById("regionId").isEmpty()) {
			alert("\u5927\u533a\u4e0d\u53ef\u4e3a\u7a7a!");
			return;
		}
		if (getSelectedTextById("regionSonId").isEmpty()) {
			alert("\u533a\u57df\u4e0d\u53ef\u4e3a\u7a7a!");
			return;
		}
		if (getSelectedTextById("provinceId").isEmpty()) {
			alert("\u7701\u4efd\u4e0d\u53ef\u4e3a\u7a7a!");
			return;
		}
		if (getSelectedTextById("cityId").isEmpty()) {
			alert("\u57ce\u5e02\u4e0d\u53ef\u4e3a\u7a7a!");
			return;
		}
		//地址
		var customerAddress = getValueByName("customer.customerAddress");
		if (customerAddress.isEmpty()) {
			alert("\u5730\u5740\u4e0d\u53ef\u4e3a\u7a7a!");
			return;
		}
	}
	if($("tradeOptionId").value.isEmpty()){
		alert("请先选择一级行业!");
		return;
	}
	var companySize = $("companySize").value.trim();
	if (!companySize.isEmpty()) {
		if (!reg.isNum(companySize)) {
			alert("\u516c\u53f8\u89c4\u6a21\u5fc5\u987b\u662f\u6570\u5b57!");
			return false;
		}
		if (companySize.length > 10) {
			alert("公司规模超长，长度应在10位以内!");
			return false;
		}
	}
	var numberShop = $("numberShop").value.trim();
	if (!numberShop.isEmpty()) {
		if (!reg.isNum(numberShop)) {
			alert("\u7f51\u70b9\u6570\u91cf\u5fc5\u987b\u662f\u6570\u5b57!");
			return false;
		}
		if (numberShop.length > 5) {
			alert("网点数量超长，长度应在5位以内!");
			return false;
		}
	}
	return true;
}
/**
 * 取消操作
 */
function cancelCallBack() {
}
/**
 *保存
 */
function doSave() {
}
/**
 * 返回
 */
function back() {
	close();
}
var treeAreasAction = "http://ICUBE_URL/tss/customer/treeAreasJson.action";
var tempAreaClass;
function getTreeAreas(areaClass) {
	tempAreaClass = areaClass;
	var fatherAreaId;
	switch (areaClass) {
	  case "2"://根据大区，取区域
		fatherAreaId = getSelectedValueById("regionId");
		break;
	  case "3"://根据区域，取省份
		fatherAreaId = getSelectedValueById("regionSonId");
		break;
	  case "4"://根据省份，取城市
		fatherAreaId = getSelectedValueById("provinceId");
		break;
	  case "5"://根据城市
		fatherAreaId = getSelectedValueById("cityId");
		break;
	}
	if (null != fatherAreaId) {
		Ajax.post(treeAreasAction, {"fatherAreaId":fatherAreaId, "areaClass":areaClass}, onAjaxResponse);
	}
}
/**
 *取城市级别
 */
function getCityClassById() {
	var cityId = getSelectedValueById("cityId");
	if(null!=cityId){
		var url = "http://ICUBE_URL/tss/customer/cityClassJson.action";
		Ajax.post(url, {ajaxTag:"ajaxTag", "mssCity.cityId":cityId}, getCityClassResponse);
	}
}
/**
 * 取到城市级别
 */
function getCityClassResponse(xhr) {
	var json = xhr.responseText;
	var ret = Ajax.eval(json);
	if(null!=ret){
		$("cityClass").value = ret.cityClass;
	}
}
/**
 * 提交后的ajax响应函数
 */
function onAjaxResponse(xhr) {
	var json = xhr.responseText;
	var ret = Ajax.eval(json);
	var obj;
	switch (tempAreaClass) {
	  case "2":
		obj = $("regionSonId");
		addOptions(obj, ret);
		setTimeout("getSontAreas()", 10);
		break;
	  case "3":
		obj = $("provinceId");
		addOptions(obj, ret);
		setTimeout("getSontAreas()", 10);
		break;
	  case "4":
		obj = $("cityId");
		addOptions(obj, ret);
		setTimeout("getSontAreas()", 10);
		break;
	  case "5":
		obj = $("areaId");
		addOptions(obj, ret);
		setTimeout("getCityClassById()", 10);
		break;
	}
}
/**
 *取下级区域
 */
function getSontAreas() {
	getTreeAreas((parseInt(tempAreaClass) + 1) + "");
}
/**
* 更新下拉选项
* 
* @param obj
* @param nodes
*/
function addOptions(obj, nodes) {
	clearOptions(obj);
	if (null != nodes) {
		if (nodes.length > 0) {
			for (var x=0;x<nodes.length;x++) {
				var key = nodes[x].areaId;
				var value = nodes[x].areaName;
				var option = document.createElement("option");
				option.text = value;
				option.value = key;
				obj.add(option);
			}
			obj.selectedIndex = 0;
		}
	}
}
/**
* 清空下拉选项
* 
* @param obj
*/
function clearOptions(obj) {
	while (obj.length > 0) {
		obj.remove(obj.length - 1);
	}
}

/**
 * type:0 (isAdd: N label, Y select)
 * type:1 (isAdd: N label, Y text) 
 * type:2 (文本) 
 * type:3 (拍照)
 * type:4 (定位)
 */
var formXml = "<form>" + "<field name='customer.customerId' type = '2'/>" 
			+ "<field name='customer.customerState' type = '2'/>" 
			+ "<field name='customer.customerName' type = '1'/>" 
			+ "<field name='customer.regionId' type = '0'/>" 
			+ "<field name='customer.regionSonId' type = '0'/>" 
			+ "<field name='customer.provinceId' type = '0'/>" 
			+ "<field name='customer.cityId' type = '0'/>" 
			+ "<field name='customer.areaId' type = '0'/>" 
			+ "<field name='customer.cityClass' type = '1'/>" 
			+ "<field name='customer.customerAddress' type = '1'/>" 
			+ "<field name='customer.companySize' type = '2'/>" 
			+ "<field name='customer.numberShop' type = '2'/>" 
			+ "<field name='customer.customerRemark' type = '2'/>" 
			+ "<field name='customer.customerPointLatlon' type = '4'/>" 
			+ "<field name='customer.customerPointExplain' type = '4'/>" 
			+ "<field name='customer.tradeId' type = '2'/>" 
			+ "<field name='customer.tradeOptionId' type = '2'/>"
			+ "<field name='customer.tradeSubsectionId' type = '2'/>" 
			+ "<field name='customer.tradeSubId' type = '2'/>"
			+ "<field name='customer.subListCode' type = '2'/>" 
			+ "<field name='customer.subListId' type = '2'/>" 
			
			+ "</form>";
/**
 * 保存店面信息到本地数据库
 */
function saveToLocal(isAdd) {
	var v = new XMLDocument();
	v.parseXmlText(formXml);
	var form = v.rootElement;
	// 保存时间(id)
	var time = new Date().getTime();
	form.setAttribute("date", time + "");
	form.setAttribute("isAdd", isAdd);
	var custName="";
	var fields = form.childNodes;
	for (var i = 0; i < fields.length; i++) {
		var field = fields[i];
		var n = field.getAttribute("name");
		var type = field.getAttribute("type");
		var value = "";
		switch (parseInt(type)) {
		  case 0:
			if (isAdd == "Y") {//新增为下接框
				var sx = document.getElementsByName(n)[0];
				if (null != sx) {
					value = sx.selectedIndex;
					for (var j = 0; j < sx.length; j++) {
						var ov = sx.options[j].value;
						var ot = sx.options[j].text;
						var element = v.createElement("option");
						element.setAttribute("value", ov);
						element.setAttribute("text", ot);
						field.appendChild(element);
					}
				} else {
					value = 0;
				}
			} else {
				value = $(n).innerHTML;
			}
			break;
		  case 1:
			if (isAdd == "Y") {
				value = replaceXmlStr(getValueByName(n));
			} else {
				value = $(n).innerHTML;
			}
			if(n=='customer.customerName'){
				custName=value;
			}
			break;
		  case 2:
			value = replaceXmlStr(getValueByName(n));
			break;
		  case 3:
			value = getValueByName(n);
			break;
		  case 4:
			value = getValueByName(n);
			break;
		  default:
			break;
		}
		field.setAttribute("value", value);
	}
	var xml = v.toXml();
	var customer = new LocalBean();
	customer.id = time;
	customer.form = xml;
	customer.name = custName;
	if (isAdd == "Y") {
		customer.isAdd = 1;
	} else {
		customer.isAdd = 0;
	}
	var t = customerDao.saveLocal(customer);
	if (t) {
		return customer.id;
	} else {
		return "";
	}
}
/**
 * 更新
 * 
 * @param id
 */
function updateToLocal(id) {
	var customer = customerDao.getLocalById(id);
	var v = new XMLDocument();
	var formXml = customer.form;
	v.parseXmlText(formXml);
	var form = v.rootElement;
	var isAdd = form.getAttribute("isAdd");
	var fields = form.childNodes;
	var custName="";
	for (var i = 0; i < fields.length; i++) {
		var field = fields[i];
		var n = field.getAttribute("name");
		var type = field.getAttribute("type");
		var value = "";
		switch (parseInt(type)) {
		  case 0:
			if (isAdd == "Y") {//新增为下接框
				var nodes = field.childNodes;
				if (null != nodes) {
					if (nodes.length > 0) {
						for (node in nodes) {
							field.removeChild(nodes[node]);
						}
					}
				}
				var sx = document.getElementsByName(n)[0];
				if (null != sx) {
					value = sx.selectedIndex;
					for (var j = 0; j < sx.length; j++) {
						var ov = sx.options[j].value;
						var ot = sx.options[j].text;
						var element = v.createElement("option");
						element.setAttribute("value", ov);
						element.setAttribute("text", ot);
						field.appendChild(element);
					}
				} else {
					value = 0;
				}
			} else {
				value = $(n).innerHTML;
			}
			break;
		  case 1:
			if (isAdd == "Y") {
				value = replaceXmlStr(getValueByName(n));
			} else {
				value = $(n).innerHTML;
			}
			if(n=='customer.customerName'){
				custName=value;
			}
			break;
		  case 2:
			value = replaceXmlStr(getValueByName(n));
			break;
		  case 3:
			value = getValueByName(n);
			break;
		  case 4:
			value = getValueByName(n);
			break;
		  default:
			break;
		}
		field.setAttribute("value", value);
	}
	var vxml = v.toXml();
	customer.form = vxml;
	customer.name = custName;
	var t = customerDao.updateLocal(customer);
	return t;
}
/*******************************************************************************
 * 客户信息本地页面接口
 * 
 * @author lijinrui
 * 
 ******************************************************************************/
/**
 * <pre>
 * 根据父窗口id查询客户信息
 * </pre>
 * 
 * @returns
 */
function getCustomerById() {
	var id = window.getParameter("id");
	var cust = customerDao.getLocalById(id);
	return cust;
}
/**
 * 初始化页面
 */
function initPage() {
	var customer = getCustomerById();
	var v = new XMLDocument();
	var formXml = customer.form;
	v.parseXmlText(formXml);
	// 表单xml结构数据
	var form = v.rootElement;
	var time = form.getAttribute("date");
	var isAdd = form.getAttribute("isAdd");
	var fields = form.childNodes;
	var divcontent = [];
	for (var i = 0; i < fields.length; i++) {
		var field = fields[i];
		var n = field.getAttribute("name");
		var type = field.getAttribute("type");
		var value = field.getAttribute("value");
		switch (parseInt(type)) {
		  case 0:
			if (isAdd == "Y") {//新增为下接框
				var sx = document.getElementsByName(n)[0];
				if (null != sx) {
					var nodes = field.childNodes;
					if (null != nodes) {
						if (nodes.length > 0) {
							for (var x=0;x<nodes.length;x++) {
								var v = nodes[x].getAttribute("value");
								var text = nodes[x].getAttribute("text");
								var option = document.createElement("option");
								option.value = v;
								option.text = text;
								sx.add(option);
							}
						}
					}
					if (!value.isEmpty()) {
						sx.selectedIndex = parseInt(value);
					}
				}
			} else {
				$(n).innerHTML = value;
			}
			break;
		  case 1:
			if (isAdd == "Y") {
				var ele = document.getElementsByName(n);
				if (null != ele && ele.length > 0) {
					ele[0].value = value;
				}
			} else {
				$(n).innerHTML = value;
			}
			break;
		  case 2:
			var ele = document.getElementsByName(n);
			if (null != ele && ele.length > 0) {
				ele[0].value = value;
			}
			break;
		  case 3:
			var ele = document.getElementsByName(n);
			if (null != ele && ele.length > 0) {
				ele[0].value = value;
			}
			break;
		  case 4:
			if (null != value && "" != value) {
				divcontent.push("<input type='hidden' name='" + n + "' value='" + value + "'/>");
			}
			break;
		  default:
			break;
		}
	}
	var mdiv = document.getElementById("latDiv");
	var con = divcontent.join("");
	mdiv.innerHTML = con;
}
function updateCustomerLocal() {
	var id = window.getParameter("id");
	var t = updateToLocal(id);
	if (t) {
		alert("\u6570\u636e\u4fdd\u5b58\u6210\u529f\uff01");
	} else {
		alert("\u6570\u636e\u4fdd\u5b58\u5931\u8d25\uff01");
	}
}
/**
 * 删除
 * 
 */
function delCustomreById() {
	confirm("\u8bf7\u786e\u8ba4\u662f\u5426\u5220\u9664\u6570\u636e\uff1f", delCustomreLocalById, cancelCallBack);
}
function delCustomreLocalById() {
	var id = window.getParameter("id");
	customerDao.delLocalById(id);
	close();
}

