
/*******************************************************************************
 * 经销商拜访接口
 * 
 * @author lijinrui
 * 
 ******************************************************************************/
function checkGps() {
	try {
		var opened = Util.getGpsState();
		if (true != opened) {
			alert("发现您没有打开系统GPS，请点击确定，并在系统设置中打开GPS(勾中\"使用GPS卫星\")。", function () {
				Util.startGpsSetting();
			});
		}
	}
	catch (e) {
	}
}
/**
 *重新定位
 */
function restartPos() {
	startPos("postionCallBack", true);
	$("gps_status").innerHTML = "定位中<img src='res:image/dingwei.gif' />";
}
function startGpsIfFailed() {
}
function postionCallBack(msgType, data) {
	if (msgType == _MSG_POS_GPS || msgType == _MSG_POS_CELL) {
		$("location").value = data.pos;
		$("gps_status").innerHTML = "<img src='res:image/cell_ok.png' />";
	} else {
		if (msgType == _MSG_GPS_CITY || msgType == _MSG_CELL_CITY) {
			$("locationExplain").value = data.addr;
		} else {
			if (msgType == _MSG_ERROR_CITY) {
				$("locationExplain").value = data.addr;
			} else {
				if (msgType == _MSG_FAIL_CELL) {
					if($("location").value.isEmpty()){
						$("gps_status").innerHTML = "<a style='text-decoration:underline;' href='javascript:restartPos();'>点击重新开始定位。</a>";
					}
				}
			}
		}
	}
}
/**
 *展开
 */
function openInfo(divId, imgId) {
	var baseDiv = $(divId);
	var img = $(imgId);
	if (baseDiv.style.display == "none") {
		baseDiv.style.display = "block";
		img.src = "res:image/treeClose.png";
	} else {
		baseDiv.style.display = "none";
		img.src = "res:image/treeOpen.png";
	}
}
/**
 * 多选
 */
function checkSelect(id, groupId, sonid) {
	var checks = document.getElementsByName("values.name" + id);
	var check;
	for (var x=0;x<checks.length;x++) {
		check = checks[x];
		if (check.checked) {
			if (check.id != groupId) {
				check.checked = false;
			}
		}
	}
}
var formXml = "<form>" + "</form>";


function successBack(response){
    if(response.status==200){
		var res=response.responseText.toJSON();
		if(res.flag){
			alert(res.msg,function(){
				 if(res.localId.isNotEmpty()){
					delDealerVisitPic(res.localId);
					dealerVisitDao.delLocalById(res.localId);
				 }
				 close();
			});
		}else{
			alert(res.msg);
		}
    }
 }
function failBack(response){
     var text = response.objName+"失败，状态为："+response.status;
     Log.i("specialUp",text);
}
/*******************************************************************************
 * 经销商拜访本地页面接口
 * 
 * @author lijinrui
 * 
 ******************************************************************************/
/**
 * 根据父窗口id查询经销商信息
 * @returns
 */
function getDealerVisitById() {
	var id = window.getParameter("id");
	var dealerVisit = dealerVisitDao.getLocalById(id);
	return dealerVisit;
}
/**
 * 恢复表单页面
 */
function initPage(){
	var divcontent = [];
	var picIdArr=[];
	var dealerVisit=getDealerVisitById();
	var v = new XMLDocument();
	v.parseXmlText(dealerVisit.form);
	var form = v.rootElement;
	// 表单xml结构数据
	var formid=form.getAttribute("formid");
	var beginDate=form.getAttribute("beginDate");
	var location=form.getAttribute("location");
	var date=form.getAttribute("date");
	var dealerId=form.getAttribute("dealerId");
	var release=form.getAttribute("release");
	var locationExplain=form.getAttribute("locationExplain");
	
	$("dealerId").value=dealerId;
	$("beginDate").value=beginDate;
	$("formId").value=formid;
	$("formRelease").value=release;
	$("location").value=location;
	$("locationExplain").value=locationExplain;
	
	divcontent.push("<div class=\"container\">");
	var fields = form.childNodes;
	for(var i = 0; i < fields.length; i++){
		var field = fields[i];
		var en = field.getAttribute("ename");
		var value = field.getAttribute("value");
		var n = field.getAttribute("name");
		var kind = field.getAttribute("kind");
		var ismust = field.getAttribute("ismust");
		//属性名
		divcontent.push("<div class=\"details-left\" style=\"width:30%;margin: 0 2 0 0;\"><font>");
		divcontent.push(replaceXmlStr(en));
		divcontent.push("</font></div>");
		divcontent.push("<div style='text-align: left;vertical-align: middle;width:3%;margin: 0 3% 0 0;font-size: 1.0em;color: #000000;'>");
		if(ismust=="0"){
			divcontent.push("<font style='color:red;'>*</font>");
		}
		divcontent.push("</div>");
		//控件
		divcontent.push("<div class=\"details-right\" style=\"width:60%;\">");
		switch (parseInt(kind)){
			 case 1:// 文本框
				divcontent.push("<input type='text'  name='"+n+"' value='"+ replaceXmlStr(value)+"' prompt='文本框' promptcolor=\"gray\"/>");
			 break;
			 case 2://数值框
				divcontent.push("<input type='text' name='"+n+"' value='"+ replaceXmlStr(value)+"' prompt='数值框' promptcolor=\"gray\"/>");
			 break;
			 case 3://下拉选择框
				divcontent.push("<select name='"+n+"' class='txtWidth' style='color:black;'>");
				var nodes = field.childNodes;
				if (null != nodes) {
					if (nodes.length > 0) {
						for (var k=0;k<nodes.length;k++) {
							var ot=nodes[k].getAttribute("text");
							var ov=nodes[k].getAttribute("value");
							if(value==k){
								divcontent.push("<option value='"+ ov + "' selected='true' >"+ replaceXmlStr(ot)+ "</option>");
							}else{
								divcontent.push("<option value='"+ ov + "'>"+ replaceXmlStr(ot)+ "</option>");
							}
						}
					}
				}
				divcontent.push("</select>");
			 break;
			 case 4://单选框
			 	var nodes = field.childNodes;
				if (null != nodes) {
					if (nodes.length > 0) {
						for (var x=0;x<nodes.length;x++) {
							var ot=nodes[x].getAttribute("text");
							var ov=nodes[x].getAttribute("value");
							if(value==ov){
								divcontent.push("<input type='radio' style='color:black;' checked='true' name='"+n+"' caption='"+replaceXmlStr(ot)+"' value='"+ov+"' />");
							}else{
								divcontent.push("<input type='radio' style='color:black;' name='"+n+"' caption='"+replaceXmlStr(ot)+"' value='"+ov+"' />");
							}
						}
					}
				}	
			 break;
			 case 5://多选框
	 			var nodes = field.childNodes;
				if (null != nodes) {
					if (nodes.length > 0) {
						for (var x=0;x<nodes.length;x++) {
							var ot=nodes[x].getAttribute("text");
							var ov=nodes[x].getAttribute("value");
							var od=nodes[x].getAttribute("id");
							var js="checkSelect(\""+ n.substring(11,n.length)+"\","+od+")";
							var checkDiv="";
							if(value.indexOf(ov)>=0){
								checkDiv="<input type='checkbox' style='color:black;' checked='true' caption='"+replaceXmlStr(ot)+"' name='"+n+"' value='"+ov+"' id='"+od+"' onclick='"+js+"'/>";
							}else{
								checkDiv="<input type='checkbox' style='color:black;' caption='"+replaceXmlStr(ot)+"' name='"+n+"' value='"+ov+"' id='"+od+"' onclick='"+js+"' />"
							}
							divcontent.push(checkDiv);
						}
					}
				}			 
			 break;
			 case 6:
			 		var obj={};
					 obj.id=n;
					 obj.value=value;
					 var openCamera="openCamera(\""+n+"\")";
					 divcontent.push("<photoupload name='"+n+"' id='"+ n+"' nums='1' style='width: 70%;height: 35px;'/>");
					 divcontent.push("<div  href='"+openCamera+"'  class='photoUpload'>");
					 divcontent.push("<img src='res:image/icon/icon_camera.png' ></img></div>");
					 picIdArr.push(obj);
			 break;
			 case 7:
			 	divcontent.push("<textarea name='"+n+"' class='txtWidth'>"+replaceXmlStr(value)+"</textarea>");
			 break;
		}
		divcontent.push("</div>");
	}
	divcontent.push("</div>");
	var mdiv = $("divcontent");
	mdiv.append(divcontent.join(""));
	for(var i=0;i<picIdArr.length;i++){
		var o=picIdArr[i];
		if(o.id.isNotEmpty()){
			$(o.id).load(o.value);
		}
	}
}

/**
 * 更新
 */
function updateToLocalById(id){
	var dealerVisit = dealerVisitDao.getLocalById(id);
	var v = new XMLDocument();
	v.parseXmlText(dealerVisit.form);
	var form = v.rootElement;
	var fields = form.childNodes;
	for(var i = 0; i < fields.length; i++){
		var field = fields[i];
		var ename=field.getAttribute("ename");
		field.setAttribute("ename",replaceXmlStr(ename));
		var eleName = field.getAttribute("name");
		var kind = field.getAttribute("kind");
		var eleObj=document.getElementsByName(eleName);
		switch (parseInt(kind)){
			case 1://文本框
			case 7://大文本
				field.setAttribute("value",replaceXmlStr(eleObj[0].value));
			break;
			case 2:
				field.setAttribute("value",replaceXmlStr(eleObj[0].value));
			break;
			case 3://下拉
				field.setAttribute("value",eleObj[0].selectedIndex);
				var nodes = field.childNodes;
				if (null != nodes) {
						for (var x=0;x<nodes.length;x++) {
							var tagName=nodes[x].name;
							if(tagName=="son"){
								var sn=nodes[x].getAttribute("name");
								var sk=nodes[x].getAttribute("kind");
								var soneEleObj=document.getElementsByName(sn);
								nodes[x].setAttribute("value",replaceXmlStr(soneEleObj[0].value) );
							}else{
								var ot=nodes[x].getAttribute("text");
								nodes[x].setAttribute("text",replaceXmlStr(ot));
							}
						}
				}
			break;
			case 4://单选
				field.setAttribute("value",getCheckBoxValeByName(eleName));
				var nodes = field.childNodes;
				if (null != nodes) {
						for (var x=0;x<nodes.length;x++) {
							var tagName=nodes[x].name;
							if(tagName=="son"){
								var sn=nodes[x].getAttribute("name");
								var sk=nodes[x].getAttribute("kind");
								var soneEleObj=document.getElementsByName(sn);
								nodes[x].setAttribute("value",replaceXmlStr(soneEleObj[0].value));
							}else{
								var ot=nodes[x].getAttribute("text");
								nodes[x].setAttribute("text",replaceXmlStr(ot));
							}
						}
				}
			break;
			case 5://多选
				field.setAttribute("value",getCheckBoxValeByName(eleName));
				var nodes = field.childNodes;
				if (null != nodes) {
						for (var x=0;x<nodes.length;x++) {
							var tagName=nodes[x].name;
							if(tagName=="son"){
								var sn=nodes[x].getAttribute("name");
								var sk=nodes[x].getAttribute("kind");
								var soneEleObj=document.getElementsByName(sn);
								nodes[x].setAttribute("value",replaceXmlStr(soneEleObj[0].value));
							}else{
								var ot=nodes[x].getAttribute("text");
								nodes[x].setAttribute("text",replaceXmlStr(ot));
							}
						}
				}
			break;
			case 6://拍照
				field.setAttribute("value",eleObj[0].foldername);
			break;
		}
	}
	var vxml = v.toXml();
	dealerVisit.form = vxml;
	var t = dealerVisitDao.updateLocal(dealerVisit);
	return t;
}

function checkByLocal(){
	var reg = new Regex();
	var dealerVisit=getDealerVisitById();
	var v = new XMLDocument();
	v.parseXmlText(dealerVisit.form);
	var form = v.rootElement;
	var fields = form.childNodes;
	for(var i = 0; i < fields.length; i++){
		var field = fields[i];
		var en = field.getAttribute("ename");
		var n = field.getAttribute("name");
		var kind = field.getAttribute("kind");
		var isMust = field.getAttribute("ismust");
		var eleObj=document.getElementsByName(n);
		switch (parseInt(kind)){
			case 1://文本框
			case 7://大文本
				var value = eleObj[0].value;
				if(value.isEmpty()){//为空
					if(isMust=="0"){
						alert("请输入"+en+"!");
						return false;
					}
				}
			break;
			case 2:
				var value = eleObj[0].value;
				if(value.isEmpty()){//为空
					if(isMust=="0"){
						alert("请输入"+en+"!");
						return false;
					}
				}else{//不为空，判断是否是数字
					if (!reg.isNum(value)){
						alert(en + "必须是数字!");
						return false;
					}
				}
			break;
			case 3://下拉
				if(eleObj[0].selectedIndex==0){
					if(isMust=="0"){
						alert("请选择"+en+"!");
						return false;
					}
				}
			break;
			case 4://单选
				var rv = getRadioValeByName(n);
					if (rv.isEmpty()){
						if(isMust=="0"){
							alert("请选择"+en+"!");
							return false;
					}
				}
			break;
			case 5://多选
				var cv=getCheckBoxValeByName(n);
				if (cv.isEmpty()){
					if(isMust=="0"){
						alert("请选择"+en+"!");
						return false;
					}
				}
			break;
			case 6://拍照
				if($(n).length<1){//为空
					if(isMust=="0"){
						alert("请给"+en+"拍照!");
						return false;
					}
				}
			break;
		}
	}
	return true;
}

function updateToLocal() {
	var id = window.getParameter("id");
	var t = updateToLocalById(id);
	if (t) {
		alert("数据保存成功！");
	} else {
		alert("数据保存失败！");
	}
}
/**
 * 删除确认
 * 
 */
function delToLocal() {
	confirm("请确认是否删除数据？", delToLocalById, cancelCallBack);
}

/**
 * 删除客户拜访照片与数据 
 */
function delToLocalById() {
	var id = window.getParameter("id");
	delDealerVisitPic(id);
	dealerVisitDao.delLocalById(id);
	close();
}

/**
 *  删除客户拜访照片
 * @param  id 
 */
function delDealerVisitPic (id) {
		var dealerVisit = dealerVisitDao.getLocalById(id);
		var v = new XMLDocument();
		v.parseXmlText(dealerVisit.form);
		var form = v.rootElement;
		var fields = form.childNodes;
		for (var i = 0; i < fields.length; i++) {
			var field = fields[i];
			var kind = field.getAttribute("kind");
			var value = field.getAttribute("value");
			switch (parseInt(kind)) {
			  case 6:
				delPhotoDir(value);
				break;
			}
		}
};
/**
 * 取消操作
 */
function cancelCallBack() {}

