//

var DLG_BUF_DBNAME="dlg_buf_db_name"; //数据库名在session中的key



function initDlgBuf(userId){
	var dbName = "dlg_buf_"+userId+".db3";
	//先将当前用户的数据库名存到session中
	window.setStringSession(DLG_BUF_DBNAME,dbName);
	//初始化数据库
	var dlgDB = new DataBase();  
	if(dlgDB.db_open(dbName,true)){
		//保证有弹出框字典表
		if(!dlgDB.db_isTableExist("buf_dic")){
			var sql = "CREATE TABLE buf_dic("
			sql+="dlg_id INTEGER PRIMARY KEY,";
			sql+="dlg_name TEXT,";
			sql+="is_synced INTEGER,";
			sql+="client_ver TEXT,";
			sql+="have_all_data INTEGER,";
			sql+="is_tree INTEGER,";
			sql+="display_fileds TEXT,";
			sql+="sort_type INTEGER);";
			var status = dlgDB.db_executeUpdate(sql);
		}else{
			//设置所有允许缓存对话框的同步状态为未缓存
			var status = dlgDB.db_executeUpdate("update buf_dic set is_synced=0 where is_synced >= 0");
		}
		//
		dlgDB.db_close();
	}
}

var _dlgParam=null;//页面请求的原始参数
var _dlqReq=null; //页面请求参数的集合
var _dlgDB = null;  //本地数据库
var _dlgInfo = null; //本地数据库存的对话框信息
function openDlg(strParam){
	//window.open('res:page/dlgList.xhtml',true,false,'','dlgId=8&amp;aclType=2&amp;cbId=data.customer_id&amp;cbName=name_data.customer_id&amp;vfrCodes=');
	//解析参数
	_dlgParam = strParam;
	_dlqReq ={};
	var ps = strParam.split("&"); 
	for(var i=0; i<ps.length; i++){
		var kv = ps[i].split("=");
		_dlqReq[kv[0]]=kv[1];
	}
	//打开数据库
	_dlgDB = new DataBase();
	//alert("open");
	if(!_dlgDB.db_open(window.getStringSession(DLG_BUF_DBNAME),false))
	{
		alert("打开本地缓存数据库失败！");
		return;
	}
	//处理
	var rst = _dlgDB.db_executeQuery('select * from buf_dic where dlg_id='+ _dlqReq.dlgId);
	if(rst.length>=2){
		_dlgInfo = rst[1];
		if(_dlgInfo[2]==-1){
			//直接请求
		}else if(_dlgInfo[2]==0){
			//请求数据更新
			queryDlgData();
		}else{
			//本地有效 do nothing			
		}
	}else{
		queryDlgData();
	}
	//
	_dlgDB.db_close();
	//alert("closed");
}
function handleDlgData(rspObj){
	alert(_dlgInfo);
}

var _xmlHttpDlg=null;
function queryDlgData(_dlgInfo){
	var paramStr = "dlg_id=" + _dlqReq.dlgId + "&acl_type=" + _dlqReq.aclType;
	if(_dlgInfo!=null){
		paramStr+="&client_ver="+_dlgInfo[3];
		paramStr+="&have_all_data="+_dlgInfo[4];
	}
	//
	_xmlHttpDlg = createXmlHttpObject();
	_xmlHttpDlg.onreadystatechange = onQueryDlgData;
	_xmlHttpDlg.open("GET", "http://IORDER_URL/platform/gaea/dlgData.action?"+paramStr, false);
	_xmlHttpDlg.send();
	window.setTimeout("queryDlgDataTimeOut()",1000*60);
}

/*ajax请求获取定位任务的回调函数 */
function onQueryDlgData(){
	if(isQueryDlgDataTimeOut) return;	
	if (_xmlHttpDlg.readyState == 4){		
		var rspObj = eval('('+_xmlHttpDlg.responseText+')');
		handleDlgData(rspObj);
	}else{		
		alert("获取弹出框数据失败！");
	}	
	_xmlHttpDlg = null;
}

/*ajax请求超时处理函数*/
var isQueryDlgDataTimeOut=false;;
function queryDlgDataTimeOut(){
	if(_xmlHttpDlg==null) return;
	isQueryDlgDataTimeOut= true;	
	alert("获取弹出框数据网络请求连接超时！");
}