
/*******************************************************************************
 * 店面拜访接口
 * 
 * @author lijinrui
 * 
 ******************************************************************************/
function checkGps() {
	try {
		var opened = Util.getGpsState();
		if (true != opened) {
			alert("发现您没有打开系统GPS，请点击确定，并在系统设置中打开GPS(勾中\"使用GPS卫星\")。", function () {
				Util.startGpsSetting();
			});
		}
	}
	catch (e) {
	}
}
function restartPos() {
	startPos("postionCallBack", true);
	document.getElementById("gps_status").innerHTML = "定位中<img src='res:image/dingwei.gif' />";
}
function startGpsIfFailed() {
}
function postionCallBack(msgType, data) {
	if (msgType == _MSG_POS_GPS || msgType == _MSG_POS_CELL) {
		$("location").value = data.pos;
		$("gps_status").innerHTML = "<img src='res:image/cell_ok.png' />";
	} else {
		if (msgType == _MSG_GPS_CITY || msgType == _MSG_CELL_CITY) {
			$("locationExplain").value = data.addr;
		} else {
			if (msgType == _MSG_ERROR_CITY) {
				$("locationExplain").value = data.addr;
			} else {
				if (msgType == _MSG_FAIL_CELL) {
					if($("location").value.isEmpty()){
						$("gps_status").innerHTML = "<a style='text-decoration:underline;' href='javascript:restartPos();'>点击重新开始定位</a>";
					}
				}
			}
		}
	}
}
/**
 *展开
 */
function openInfo(divId, imgId) {
	var baseDiv = document.getElementById(divId);
	var img = document.getElementById(imgId);
	if (baseDiv.style.display == "none") {
		baseDiv.style.display = "block";
		img.src = "res:image/treeClose.png";
	} else {
		baseDiv.style.display = "none";
		img.src = "res:image/treeOpen.png";
	}
}
/**
 * 单选
 */
function expanSons(id) {
	var radios=document.getElementsByName("values.name"+id);
	if (null != radios){
		for ( var i = 0; i < radios.length; i++){
			var radio = radios[i];
			var sonDiv = $("link-" + id+"-"+radio.value);
			if (radio.checked){
				if(null!=sonDiv){
					sonDiv.style.display = "block";
				}
			}else{
				if(null!=sonDiv){
					sonDiv.style.display = "none";
				}
			}
		}
	}
}
function linkSelect(id) {
	var dom=document.getElementsByName("values.name"+id);
	if (null != dom&&dom.length>0)
	{
		var sx = dom[0];
		if(null!=sx){
			for(var i=0;i<sx.length;i++){
				var sv=sx.options[i].value;
				var fDiv = $("link-" + id+"-"+sv);
				if(i==sx.selectedIndex){
					if (null != fDiv) {
						fDiv.style.display = "block";
					}
				}else{
					if (null != fDiv) {
						fDiv.style.display = "none";
					}
				}
			}
		}
	}
}
/**
 * 多选
 */
function checkSelect(id, groupId, sonid) {
	var checks = document.getElementsByName("values.name" + id);
	var check;
	for (var x=0;x<checks.length;x++) {
		check = checks[x];
		if (check.checked) {
			if (check.id.split("-")[0] != groupId) {
				check.checked = false;
			}
		}
	}
	for (var x=0;x<checks.length;x++) {
		check = checks[x];
		var fDiv = $("link-" + id+"-"+check.value);
		if (check.checked) {
			if (null != fDiv) {
				fDiv.style.display = "block";
			}
		}else{
			if (null != fDiv) {
				fDiv.style.display = "none";
			}
		}
	}
}

function successBack(response){
    if(response.status==200){
		var res=response.responseText.toJSON();
		if(res.flag){
			alert(res.msg,function(){
				if(res.localId.isNotEmpty()){
					 delStoreVisitPic(res.localId);
					 storeVisitDao.delLocalById(res.localId);
				 }
				 close();
			});
		}else{
			alert(res.msg);
		}
    }
 }
function failBack(response){
     var text = response.objName+"失败，状态为："+response.status;
     Log.i("specialUp",text);
}

var formXml = "<form>" 
	+ "</form>";
/*******************************************************************************
 * 巡访本地页面接口
 * 
 * @author lijinrui
 * 
 ******************************************************************************/
/**
 * 根据父窗口id查询巡店信息
 * @returns
 */
function getStoreVisitById() {
	var id = window.getParameter("id");
	var storeVisit = storeVisitDao.getLocalById(id);
	return storeVisit;
}
/**
 * 恢复表单页面
 */
function initPage(){
	var divcontent = [];
	var picIdArr=[];
	var storeVisit=getStoreVisitById();
	var v = new XMLDocument();
	v.parseXmlText(storeVisit.form);
	var form = v.rootElement;
	// 表单xml结构数据
	var formid=form.getAttribute("formid");
	var beginDate=form.getAttribute("beginDate");
	var location=form.getAttribute("location");
	var date=form.getAttribute("date");
	var storeId=form.getAttribute("storeId");
	var release=form.getAttribute("release");
	var locationExplain=form.getAttribute("locationExplain");
	$("storeId").value=storeId;
	$("beginDate").value=beginDate;
	$("formId").value=formid;
	$("formRelease").value=release;
	$("location").value=location;
	$("locationExplain").value=locationExplain;
	//类型
	var types=form.childNodes;
	for(var k=0;k<types.length;k++){
		//类型节点
		var type=types[k];
		//类型名
		var typeName=type.getAttribute("name");
		//类型Id
		var typeId=type.getAttribute("id");
		//该类型所有字段
		var fields = type.childNodes;
		divcontent.push("<div class='container' >");
		//==类型名start==
		divcontent.push("<div>");
			divcontent.push("<div class='details-left2' style='width:100%;margin: 0 2 0 0;text-align:left;'>");
				divcontent.push("<font style='font-size:1.4em;'>"+replaceXmlStr(typeName)+"</font><font style='color:#EE6B01'>:</font>");
				//==展开图start
				var imgId="img"+typeId;
				var divId="div"+typeId;
				if(fields.length>0){
					var opinfo="openInfo(\""+divId+"\",\""+imgId+"\")";
					divcontent.push("<img src='res:image/treeClose.png' id='"+imgId+"' discache='false' href='"+opinfo+"' style='width:15px;'/>");
				}
			divcontent.push("</div>");
		divcontent.push("</div>");
		//==类型名end==
		divcontent.push("<div id='"+divId+"' style='display:block;'>");
		divcontent.push("<hr/>");
		//迭代本类所有字段
		for(var i = 0; i < fields.length; i++){
			var field = fields[i];
			var en = field.getAttribute("ename");
			var propid = field.getAttribute("propid");
			var value = field.getAttribute("value");
			var n = field.getAttribute("name");
			var ismust = field.getAttribute("ismust");
			var kind = field.getAttribute("kind");
			//属性名
			divcontent.push("<div class=\"details-left\" style=\"width:30%;margin: 0 2 0 0;\">"+replaceXmlStr(en)+"</div>");
			divcontent.push("<div style='text-align: left;vertical-align: middle;width:3%;margin: 0 3% 0 0;font-size: 1.0em;color: #000000;'>");
			if(ismust=="0"){
				divcontent.push("<font style='color:red;'>*</font>");
			}
			divcontent.push("</div>");
			//控件
			divcontent.push("<div class='details-right' style='width:60%;'>");
			switch (parseInt(kind)){
				 case 1:// 文本框
					divcontent.push("<input type='text'  name='"+n+"' value='"+replaceXmlStr(value)+"' prompt='文本框' promptcolor='gray' />");
				 break;
				 case 2://数值框
					divcontent.push("<input type='text' name='"+n+"' value='"+replaceXmlStr(value)+"' prompt='数值框' promptcolor='gray' />");
				 break;
				 case 3://下拉选择框
					var nodes = field.childNodes;
					if (null != nodes) {
						if (nodes.length > 0) {
							var optionConten="";
							var sonContent="";
							var linkJs="linkSelect(\""+propid+"\")";
							optionConten+="<select name='"+n+"' id='"+propid+"' onchange='"+linkJs+"' class='txtWidth' style='color:black;'>";
							var selectOv="";
							for (var j=0;j<nodes.length;j++) {
								var tagName=nodes[j].name;
								if(tagName=="option"){
									var ot=nodes[j].getAttribute("text");
									var ov=nodes[j].getAttribute("value");
									var od=nodes[j].getAttribute("id");
									if(value==j){
										selectOv=ov;
										optionConten+="<option value='"+ ov + "' id='"+od+"' selected='true' >"+ replaceXmlStr(ot)+ "</option>";
									}else{
										optionConten+="<option value='"+ ov + "' id='"+od+"' >"+ replaceXmlStr(ot)+ "</option>";
									}
								}else if(tagName=="son"){
									var sv=nodes[j].getAttribute("value");
									var sn=nodes[j].getAttribute("name");
									var sk=nodes[j].getAttribute("kind");
									var sp=nodes[j].getAttribute("parentid");
									var sdivId="link-"+propid+"-"+sp;
									if(sp==selectOv){
										sonContent+="<div id='"+sdivId+"' style='display:block;' >";
									}else{
										sonContent+="<div id='"+sdivId+"' style='display:none;' >";
									}
									switch(parseInt(sk)){	
										case 1:
											sonContent+="<input type='text' name='"+sn+"' prompt='文本框' value='"+replaceXmlStr(sv)+"' promptcolor='gray'/>";
										break;
										case 2:
											sonContent+="<input type='text' name='"+sn+"' prompt='数值框' value='"+replaceXmlStr(sv)+"' promptcolor='gray'/>";
										break;
										case 6:
											var obj={};
											 obj.id=sn;
											 obj.value=sv;
											 var openCamera="openCamera(\""+sn+"\")";
											 sonContent+="<photoupload name='"+sn+"' id='"+ sn+"' nums='1' style='width: 70%;height: 35px;'/>";
											 sonContent+="<div  href='"+openCamera+"'  class='photoUpload'>";
											 sonContent+="<img src='res:image/icon/icon_camera.png' ></img></div>";
											 picIdArr.push(obj);
										break;
										case 7:
											sonContent+="<textarea name='"+sn+"' class='txtWidth'>"+replaceXmlStr(sv)+"</textarea>";
										break;
									}
									sonContent+="</div>";
								}
							}
							optionConten+="</select>";
							divcontent.push(optionConten);
							divcontent.push(sonContent);
						}
					}
				 break;
				 case 4://单选框
				 	var nodes = field.childNodes;
					if (null != nodes) {
						if (nodes.length > 0) {
							var optionConten="";
							var sonContent="";
							for (var x=0;x<nodes.length;x++) {
								var tagName=nodes[x].name;
								if(tagName=="option"){
									var ot=nodes[x].getAttribute("text");
									var ov=nodes[x].getAttribute("value");
									var haveSonjs="expanSons(\""+propid+"\")";
									if(value==ov){
										optionConten+=("<input type='radio' style='color:black;' checked='true' name='"+n+"' caption='"+replaceXmlStr(ot)+"' value='"+ov+"' onclick='"+haveSonjs+"'/>");
									}else{
										optionConten+=("<input type='radio' style='color:black;' name='"+n+"' caption='"+replaceXmlStr(ot)+"' value='"+ov+"'  onclick='"+haveSonjs+"'/>");
									}
								}else if(tagName=="son"){
									var sv=nodes[x].getAttribute("value");
									var sn=nodes[x].getAttribute("name");
									var sk=nodes[x].getAttribute("kind");
									var sp=nodes[x].getAttribute("parentid");
									var sdivId="link-"+propid+"-"+sp;
									if(value==sp){
										sonContent+="<div id='"+sdivId+"' style='display:block;' >";
									}else{
										sonContent+="<div id='"+sdivId+"' style='display:none;' >";
									}
									switch(parseInt(sk)){	
										case 1:
											sonContent+="<input type='text' name='"+sn+"' prompt='文本框' value='"+replaceXmlStr(sv)+"' promptcolor='gray'/>";
										break;
										case 2:
											sonContent+="<input type='text' name='"+sn+"' prompt='数值框' value='"+replaceXmlStr(sv)+"' promptcolor='gray'/>";
										break;
										case 6:
												var obj={};
											 obj.id=sn;
											 obj.value=sv;
											 var openCamera="openCamera(\""+sn+"\")";
											 sonContent+="<photoupload name='"+sn+"' id='"+ sn+"' nums='1' style='width: 70%;height: 35px;'/>";
											 sonContent+="<div  href='"+openCamera+"'  class='photoUpload'>";
											 sonContent+="<img src='res:image/icon/icon_camera.png' ></img></div>";
											 picIdArr.push(obj);
										break;
										case 7:
											sonContent+="<textarea name='"+sn+"' class='txtWidth'>"+replaceXmlStr(sv)+"</textarea>";
										break;
										
									}
									sonContent+="</div>";
								}
							}
							divcontent.push(optionConten);
							divcontent.push(sonContent);
						}
					}
				 break;
				 case 5://多选框
		 			var nodes = field.childNodes;
					if (null != nodes) {
						if (nodes.length > 0) {
							for (var x=0;x<nodes.length;x++) {
								var tagName=nodes[x].name;
								if(tagName=="option"){
									var ot=nodes[x].getAttribute("text");
									var ov=nodes[x].getAttribute("value");
									var od=nodes[x].getAttribute("id");
									var osd=nodes[x].getAttribute("sonid");
									var js="checkSelect(\""+ propid+"\",\""+od+"\",\""+osd+"\")";
									var sid=od+"-"+osd;
									var checkDiv="";
									if(value.indexOf(ov)>=0){
										checkDiv="<input type='checkbox' style='color:black;' id='"+sid+"' checked='true' caption='"+replaceXmlStr(ot)+"' name='"+n+"' value='"+ov+"' onclick='"+js+"'/>";
									}else{
										checkDiv="<input type='checkbox' style='color:black;' id='"+sid+"' caption='"+replaceXmlStr(ot)+"' name='"+n+"' value='"+ov+"' onclick='"+js+"' />"
									}
									divcontent.push(checkDiv);
								}else{
									var sv=nodes[x].getAttribute("value");
									var sn=nodes[x].getAttribute("name");
									var sk=nodes[x].getAttribute("kind");
									var sp=nodes[x].getAttribute("parentid");
									var sdivId="link-"+propid+"-"+sp;
									if(value.indexOf(sp)>=0){
										divcontent.push("<div id='"+sdivId+"' style='display:block;' >");
									}else{
										divcontent.push("<div id='"+sdivId+"' style='display:none;' >");
									}
									switch(parseInt(sk)){	
										case 1:
											divcontent.push("<input type='text' name='"+sn+"' value='"+replaceXmlStr(sv)+"' prompt='文本框' promptcolor='gray'/>");
										break;
										case 2:
											divcontent.push("<input type='text' name='"+sn+"' value='"+replaceXmlStr(sv)+"' prompt='数值框' promptcolor='gray'/>");
											break;
										case 6:
												var obj={};
											 obj.id=sn;
											 obj.value=sv;
											 var openCamera="openCamera(\""+sn+"\")";
											 sonContent+="<photoupload name='"+sn+"' id='"+ sn+"' nums='1' style='width: 70%;height: 35px;'/>";
											 sonContent+="<div  href='"+openCamera+"'  class='photoUpload'>";
											 sonContent+="<img src='res:image/icon/icon_camera.png' ></img></div>";
											 picIdArr.push(obj);
										break;
										case 7:
											divcontent.push("<textarea name='"+sn+"' class='txtWidth'>"+replaceXmlStr(sv)+"</textarea>");
										break;
									}
									divcontent.push("</div>");
								}
							}
						}
					}
				 break;
				 case 6:
					 var obj={};
					 obj.id=n;
					 obj.value=value;
					 var openCamera="openCamera(\""+n+"\")";
					 divcontent.push("<photoupload name='"+n+"' id='"+ n+"' nums='1' style='width: 70%;height: 35px;'/>");
					 divcontent.push("<div  href='"+openCamera+"'  class='photoUpload'>");
					 divcontent.push("<img src='res:image/icon/icon_camera.png' ></img></div>");
					 picIdArr.push(obj);
				 break;
				 case 7:
				 divcontent.push("<textarea name='"+n+"' class='txtWidth'>"+value+"</textarea>");
				 break;
			}
			divcontent.push("</div>");
		}			
		divcontent.push("</div>");
		divcontent.push("</div>");
	}
	var mdiv = $("divcontent");
	mdiv.innerHTML = divcontent.join("");
	//Log.i("d",divcontent.join(""));
	//alert(picIdArr.length);
	for(var i=0;i<picIdArr.length;i++){
		var o=picIdArr[i];
		if(o.id.isNotEmpty()){
			$(o.id).load(o.value);
		}
	}
}

/**
 * 更新
 */
function updateToLocalById(id){
	var storeVisit = storeVisitDao.getLocalById(id);
	var v = new XMLDocument();
	v.parseXmlText(storeVisit.form);
	var form = v.rootElement;
	var types=form.childNodes;
	for(var k=0;k<types.length;k++){
		//该类型所有字段
		var type=types[k];
		var typeName=type.getAttribute("name");
		type.setAttribute("name",replaceXmlStr(typeName));
		var fields = type.childNodes;
		for(var i = 0; i < fields.length; i++){
			var field = fields[i];
			var ename=field.getAttribute("ename");
			field.setAttribute("ename",replaceXmlStr(ename));
			var n = field.getAttribute("name");
			var kind = field.getAttribute("kind");
			var eleObj=document.getElementsByName(n);
			
			switch (parseInt(kind)){
				case 1://文本框
				case 7://大文本
					field.setAttribute("value",replaceXmlStr(eleObj[0].value));
				break;
				case 2:
					field.setAttribute("value",replaceXmlStr(eleObj[0].value));
				break;
				case 3://下拉
					field.setAttribute("value",eleObj[0].selectedIndex);
					var nodes = field.childNodes;
					if (null != nodes) {
						for (var x=0;x<nodes.length;x++) {
							var tagName=nodes[x].name;
							if(tagName=="son"){
								var sn=nodes[x].getAttribute("name");
								var sk=nodes[x].getAttribute("kind");
								var soneEleObj=document.getElementsByName(sn);
								switch(parseInt(sk)){
									case 6:
										nodes[x].setAttribute("value",replaceXmlStr(soneEleObj[0].foldername) );
									break;
									default:
										nodes[x].setAttribute("value",replaceXmlStr(soneEleObj[0].value) );
									break;
								}
							}else{
								var ot=nodes[x].getAttribute("text");
								nodes[x].setAttribute("text",replaceXmlStr(ot));
							}
						}
					}
				break;
				case 4://单选
					field.setAttribute("value",getCheckBoxValeByName(n));
					var nodes = field.childNodes;
					if (null != nodes) {
						for (var x=0;x<nodes.length;x++) {
							var tagName=nodes[x].name;
							if(tagName=="son"){
								var sn=nodes[x].getAttribute("name");
								var sk=nodes[x].getAttribute("kind");
								var soneEleObj=document.getElementsByName(sn);
								switch(parseInt(sk)){
									case 6:
										nodes[x].setAttribute("value",replaceXmlStr(soneEleObj[0].foldername) );
									break;
									default:
										nodes[x].setAttribute("value",replaceXmlStr(soneEleObj[0].value) );
									break;
								}
							}else{
								var ot=nodes[x].getAttribute("text");
								nodes[x].setAttribute("text",replaceXmlStr(ot));
							}
						}
					}
				break;
				case 5://多选
					field.setAttribute("value",getCheckBoxValeByName(n));
					var nodes = field.childNodes;
					if (null != nodes) {
						for (var x=0;x<nodes.length;x++) {
							var tagName=nodes[x].name;
							if(tagName=="son"){
								var sn=nodes[x].getAttribute("name");
								var sk=nodes[x].getAttribute("kind");
								var soneEleObj=document.getElementsByName(sn);
								switch(parseInt(sk)){
									case 6:
										nodes[x].setAttribute("value",replaceXmlStr(soneEleObj[0].foldername) );
									break;
									default:
										nodes[x].setAttribute("value",replaceXmlStr(soneEleObj[0].value) );
									break;
								}
							}else{
								var ot=nodes[x].getAttribute("text");
								nodes[x].setAttribute("text",replaceXmlStr(ot));
							}
						}
					}
				break;
				case 6://拍照
					field.setAttribute("value",eleObj[0].foldername);
				break;
			}
		}
	}
	var vxml = v.toXml();
	storeVisit.form = vxml;
	var t = storeVisitDao.updateLocal(storeVisit);
	return t;
}

function checkByLocal(){
	var reg = new Regex();
	var storeVisit=getStoreVisitById();
	var v = new XMLDocument();
	v.parseXmlText(storeVisit.form);
	var form = v.rootElement;
	var types=form.childNodes;
	for(var k=0;k<types.length;k++){
		//该类型所有字段
		var type=types[k];
		var fields = type.childNodes;
		for(var i = 0; i < fields.length; i++){
			var field = fields[i];
			var en = field.getAttribute("ename");
			var n = field.getAttribute("name");
			var kind = field.getAttribute("kind");
			var isMust = field.getAttribute("ismust");
			var eleObj=document.getElementsByName(n);
			switch (parseInt(kind)){
				case 1://文本框
				case 7://大文本
					var value = eleObj[0].value;
					if(value.isEmpty()){//为空
						if(isMust=="0"){
							alert("请输入"+en+"!");
							return false;
						}
					}
				break;
				case 2:
					var value = eleObj[0].value;
					if(value.isEmpty()){//为空
						if(isMust=="0"){
							alert("请输入"+en+"!");
							return false;
						}
					}else{//不为空，判断是否是数字
						if (!reg.isNum(value)){
							alert(en + "必须是数字!");
							return false;
						}
					}
				break;
				case 3://下拉
					if(eleObj[0].selectedIndex==0){
						if(isMust=="0"){
							alert("请选择"+en+"!");
							return false;
						}
					}
				break;
				case 4://单选
					var rv = getRadioValeByName(n);
						if (rv.isEmpty()){
							if(isMust=="0"){
								alert("请选择"+en+"!");
								return false;
						}
					}
				break;
				case 5://多选
					var cv=getCheckBoxValeByName(n);
					if (cv.isEmpty()){
						if(isMust=="0"){
							alert("请选择"+en+"!");
							return false;
						}
					}
				break;
				case 6://拍照
					if($(n).length<1){//为空
						if(isMust=="0"){
							alert("请给"+en+"拍照!");
							return false;
						}
					}
				break;
			}
		}
	}
	return true;
}

function updateToLocal() {
	var id = window.getParameter("id");
	var t = updateToLocalById(id);
	if (t) {
		alert("数据保存成功！");
	} else {
		alert("数据保存失败！");
	}
}
/**
 * 删除确认
 * 
 */
function delToLocal() {
	confirm("请确认是否删除数据？", delToLocalById, cancelCallBack);
}

/**
 * 删除客户拜访照片与数据 
 */
function delToLocalById() {
	var id = window.getParameter("id");
	delStoreVisitPic(id);
	storeVisitDao.delLocalById(id);
	close();
}

/**
 *  删除客户拜访照片
 * @param  id 
 */
function delStoreVisitPic (id) {
		var storeVisit = storeVisitDao.getLocalById(id);
		var v = new XMLDocument();
		v.parseXmlText(storeVisit.form);
		var form = v.rootElement;
		var types=form.childNodes;
		for(var k=0;k<types.length;k++){
			//该类型所有字段
			var type=types[k];
			var fields = type.childNodes;
			for(var i = 0; i < fields.length; i++){
				var field = fields[i];
				var kind = field.getAttribute("kind");
				var value = field.getAttribute("value");
				switch (parseInt(kind)) {
				  case 6:
					delPhotoDir(value);
					break;
				}
				var sons=field.childNodes;
				if(null!=sons){
					if(sons.length>0){
						for (var x=0;x<sons.length;x++) {
							var tagName=sons[x].name;
							if(tagName=="son"){
								var sv=sons[x].getAttribute("value");
								var sk=sons[x].getAttribute("kind");
								switch (parseInt(sk)){
									  	case 6:
											delPhotoDir(sv);
									 	break;
								}
								
							}
						}
						
					}
				}
			}
		}
};
/**
 * 取消操作
 */
function cancelCallBack() {}
	