/**
外部可用的函数

	aclType: 是否权限控制 0不控制 2控制
	cbId: 选择客户后回填客户ID的控件ID 
	cbName: 选择客户后回填客户名称的控件ID 
	bufKey：“最近所选的客户”的本地缓存key
	callBackFunBtn：触发回调函数的隐藏按钮的ID，回调函数中可调用window.getStringSession("_session_selected_customer")获取，值的格式为“客户ID,客户名称”
					
1、selectCustomer(aclType, cbId, cbName, bufKey,callBackFunBtn)

	//记录已选的客户 作为“最近所选的客户”用
2、recordRecentCustomer(customerId, bufKey)
其他函数为仅供本脚本内部使用，请勿调用
*/
	/*-- 
		客户弹出框调用脚本
		调用方法:
		1、在脚本区include本文件 如下所示
		<s:include value="/baseapp/cm/gaea/customerDlgJs.jsp"></s:include>	
		2、在页面的某个链接调用selectCustomer方法 如下所示
		<input type="button" onclick="selectCustomer('2','customerId','customerName');" value="..."/>
	 --*/
	
	var _customer_cbId;
	var _customer_cbName;
	var _callback_fun_btn;
	var postion_ctrl_id = "";
	function selectCustomer(aclType, cbId, cbName, bufKey, callBackFunBtn){	
		_customer_cbId = cbId;
		_customer_cbName = cbName;
		_callback_fun_btn = callBackFunBtn||"";
		//拼查询条件
		var param = "aclType=" + aclType;
		param+="&cbId=" + cbId;
		param+="&cbName=" + cbName;
		param+="&cbFunBtn=" + _callback_fun_btn;
		param+="&parentWinId=" + window.id;		
		
		//附加条件
		var hasInitCondition = false;
		//初始条件
		//var selectedData = document.getElementById(cbId).value;
		//var inputCondition = document.getElementById(cbName).value;	
		//if((selectedData==null || selectedData=="") && inputCondition){		
		//		param+="&queryCondition=" + Util.urlEncode(inputCondition,1);;
		//}
		//位置条件
		var curLocation = "";
		if(postion_ctrl_id){
			curLocation = document.getElementById(postion_ctrl_id).value;
			if(curLocation){
				param+="&queryPos=" + curLocation;
			}			
		}
		//最近已选的客户
		if(!hasInitCondition){
			var recentIds = getRecentCustomer(bufKey);
			param+="&recentIds=" + recentIds;
		}

		//ajax请求
		var os=Util.getOs();
		if(os.indexOf('iPhone')>=0){
			fuckIphone(param);
		}else{
			var url = "http://IORDER_URL/baseapp/cm/gaea/dlgShow.action?page.recPerPage=10"; 
			var requestHeader = '{ "Content-Type":"application/x-www-form-urlencoded; charset=utf-8","Accept-Language":"zh-cn"}';
			var customerDlgAjax = new Ajax(url,"POST",param,successSelCustomer,failSelCustomer,requestHeader,true);
			customerDlgAjax.send();	
		}
	}
	//================rubbish to delete=================
	var _xmlHttpCusDlg=null;
	function fuckIphone(param){
			_xmlHttpCusDlg = createXmlHttpObject();
			_xmlHttpCusDlg.onreadystatechange = onCusDlg;
			_xmlHttpCusDlg.isShowProgress = true;
			_xmlHttpCusDlg.setRequestHeader("Content-Type", "application/x-www-form-urlencoded; charset=utf-8");
			_xmlHttpCusDlg.open("POST", "http://IORDER_URL/baseapp/cm/gaea/dlgShow.action?page.recPerPage=10", false);
			_xmlHttpCusDlg.send(param);
	} 
	function onCusDlg(){
		if (_xmlHttpCusDlg.readyState == 4 && _xmlHttpCusDlg.status==200){	
			var strRsp = _xmlHttpCusDlg.responseText;		
			if(strRsp.length>200){
				window.openData(strRsp);
			}else{
				var jsonObj = null; 
				if(strRsp.length>0){
					jsonObj = eval( "(" + strRsp +")" );				
				}
				if(jsonObj){
					if(jsonObj.num>0){
						selectOneCustomer(jsonObj);
					}else{
						alert("没有查询到符合条件的客户！");
					}
				}else{
					alert("查询客户信息出错！");
				}
			}
		}else{
			alert("查询客户信息时发生网络错误！");
		}
	}
	//选定一个客户 对调用者页面设置相应
	function selectOneCustomer(jsonObj){
			document.getElementById(_customer_cbId).value = jsonObj.id;
			var ele = document.getElementById(_customer_cbName);
			if(ele.type && ele.type=="text")
				ele.value=jsonObj.name;
			else
				ele.innerHTML=jsonObj.name;

			if(_callback_fun_btn!=''){
				var str = jsonObj.id + "," +jsonObj.name;
				window.setStringSession("_session_selected_customer",str);	
				document.getElementById(_callback_fun_btn).click();
			}
	}
	//=================================
	//成功回调函数 200 状态码
	function successSelCustomer(ajax){
		var strRsp = ajax.responseText;		
		if(strRsp.length>200){
			window.openData(strRsp);
		}else if(strRsp.indexOf("重新登录")>=0){
			alert("由于长时间未操作，您的登录已经过期，请重新登录！",reLogin);
		}else if(strRsp.indexOf("页面不存在")>=0){
			alert("未找到请求的页面,请联系管理员！");
		}else{
			var jsonObj = eval( "(" + strRsp +")" );
			if(jsonObj){
				if(jsonObj.num>0){
					selectOneCustomer(jsonObj);
				}else{
					alert("没有查询到符合条件的客户！");
				}
			}else{
				alert("查询客户信息出错！");
			}
		}
	}

	//失败回调函数 404|412|500
	function failSelCustomer (ajax){
		if(404==ajax.status)
			alert("网络连接失败!");
		else
			alert(ajax.responseText);
	}	
	function clearSelectedCustomer(cbId){
		document.getElementById(cbId).value = "";
	}
	var BUF_TABLE_PREFIX="buf_recent_customer_";
	/*--获取最近选择的客户数据 --*/
	function getRecentCustomer(bufKey){
		bufKey = bufKey || "" ;
		var strIds = ""; 
		var curUserId = window.getStringSession("session_user_id");
		var tblName = BUF_TABLE_PREFIX + curUserId + "_"+bufKey;
		var db = new DataBase();  
		if(db.db_open("customer_cache",true)){
			var sql  = "SELECT * FROM "+ tblName + " ORDER BY access_time DESC LIMIT 20"
			var result = db.db_executeQuery(sql);
			if(result){
				for (var i = 1 ; i < result.length; i=i+1) { 
					strIds = strIds + "," + result[i][0];
				}
				if(strIds.length>0){
					strIds = strIds.substr(1); 
				}
			}
			db.db_close();
		}else{
           alert("打开缓存数据库失败！");
       }  
       return strIds;
	}
	/*--记录本次选择的客户 以备下次选择时候用 --*/
	function recordRecentCustomer(customerId, bufKey){
		bufKey = bufKey || "" ;
		var curUserId = window.getStringSession("session_user_id");
		var tblName = BUF_TABLE_PREFIX + curUserId + "_"+bufKey;
		var db = new DataBase();  
		if(db.db_open("customer_cache",true)){
			//检测表是否存在
			if(!db.db_isTableExist(tblName)){
				var sql = "CREATE TABLE "+tblName+"("
				sql+="data_id TEXT PRIMARY KEY,";
				sql+="access_time TEXT)";
				var status = db.db_executeUpdate(sql);
			}
			//记录本次选择的数据
			var now = new Date();
			var sqlInsert="INSERT OR REPLACE INTO "+ tblName +"(data_id, access_time) VALUES ('" + customerId + "', '" +now.toString()+  "')";
			db.db_executeUpdate(sqlInsert);
			db.db_close();
		}else{
           alert("打开缓存数据库失败！");
       }  		
	}	