var ORDER_UPLOAD_TYPE_SINGLE = "single";
var ORDER_UPLOAD_TYPE_MULTIPLE = "multiple";

/**
 * 建表，orderInfo
 * 
 * @returns
 */
function ensureOrderInfoTbl()
{
	var sql = "create table orderInfo(orderId TEXT, userId TEXT, customerId TEXT, json TEXT, orderUploadType TEXT)";
	var ret = DBHelper.isTableExist("orderInfo");
	if(ret == false){
		//建表
		ret = DBHelper.update(sql);
	}
	if(ret == false){
		alert("创建本地订单表失败！");
		window.close();
	}
	return ret;
}


function ensureOrderInfoListTbl()
{
	var sql = "create table orderInfoList(orderId TEXT, commodityId TEXT, json TEXT)";
	var ret = DBHelper.isTableExist("orderInfoList");
	if(ret == false){
		//建表
		ret = DBHelper.update(sql);
	}
	if(ret == false){
		alert("创建订单明细表失败！");
		window.close();
	}
	return ret;
}

function saveOrderInfo(OrderObj, orderUploadType)
{
	var orderObjJson = JSON.stringify(OrderObj).replaceAll("'", "\\'");
	var deleteSql = "delete from orderInfo where orderId = '" + OrderObj.orderIdStr + "'";
	var insertSql = "insert into orderInfo(orderId, userId, customerId, json, orderUploadType) values('"
													+ OrderObj.orderIdStr    +"','" 
													+ OrderObj.employeeIdStr +"','" 
													+ OrderObj.customerIdStr +"','"
													+ orderObjJson           +"','"
													+ orderUploadType		 +"')";
	DBHelper.update(deleteSql);
	var insertResult = DBHelper.update(insertSql);
	
	if (insertResult == false){
		alert("插入订单号失败！");
		window.close();
	}
	return insertResult;
}

function saveOrderInfoList(orderInfoList, OrderObj)
{
	var orderObjJson = JSON.stringify(orderInfoList).replaceAll("'", "\\'");
	var deleteSql = "delete from orderInfoList where orderId = '" + OrderObj.orderIdStr + "' and commodityId = '" + orderInfoList.commodityId  + "'";
	var insertSql = "insert into orderInfoList values('"+OrderObj.orderIdStr+"','"+orderInfoList.commodityId+"','"+orderObjJson+"')";
	
	Log.i("order", insertSql);
	DBHelper.update(deleteSql);
	var insertResult = DBHelper.update(insertSql);
	
	if (insertResult == false){
		alert("插入订单明细失败！");
		window.close();
	}
	return insertResult;
}




