var LOGIN_SALT = "fiberhome_icube_20120220_1e595";

/**
 * 获取指定ASCII文本的sha1哈希值，用小写hex字符串的形式返回结果
 * 这个函数依赖sha1.js文件
 * @param text
 * @returns
 */
function getShaByAscII(text)
{
	var sh = new window.jsSHA(text, "ASCII");
	return sh.getHash("HEX");	
}

/**
 * 
 */
function getPhoneToken()
{
	var date = new Date();
	var time = date.getTime();
	
	var sig  = getShaByAscII(LOGIN_SALT + time);
	return time + ":" + sig;
}